function [predgnd] = LDDM(trainfea,traingnd,testfea)
%Yang Mu UMass Boston
%yangmu@cs.umb.edu
%2012 Jan

%Initilization
trainnum = length(traingnd);
%find the number of samples for each class
[ unum times] = Findmostnumber( traingnd);
least = times(end);
k1 = max(floor(0.1*least),2);
k2 = max(floor(0.1*least),3);
beta = 0.1;
options.k1 = k1;
options.k2 = k2;
options.beta = beta;
options.gnd = traingnd;
K = round(0.1*trainnum);
thd = 0.8;

%training local distance matrices for each training sample
for Loopnumi = 1:trainnum
    %     Loopnumi: focal sample
    [Udla{Loopnumi} E{Loopnumi}] = localLDDM(Loopnumi,trainfea,options);
end

%W is the set of projection matric, compute the approriate dimension
W = cell(trainnum,1);
for Loopnum = 1:trainnum
    cUdla = Udla{Loopnum};
    cE = E{Loopnum};
    selectedidx = (cE<0);
    Es = cE(selectedidx);
    Es = abs(Es);
    cumE = cumsum(Es);
    if isempty(cumE)
        selecteddim = 1:2;
    else
        selecteddim = find(cumE/cumE(end) <thd);
        if isempty(selecteddim)
            selecteddim = 1:2;
        end
    end
    W{Loopnum} = cUdla(:,selecteddim);
end


%testing, probability approach for LDDM
ulabel = unique(traingnd);
testnum = size(testfea,1);
tclassnum = length(unique(traingnd));%total class number
predict = zeros(testnum,trainnum,tclassnum); %testnum * trainnum * trainclassnum
predict2 = zeros(testnum,trainnum,tclassnum); %testnum * trainnum * trainclassnum
for Loopnum = 1:trainnum
    TrainProj = trainfea*W{Loopnum};
    TestProj = testfea*W{Loopnum};
    focalsample = TrainProj(Loopnum,:);
    dist1 = Dist(focalsample,TestProj);
    distancemat2 = Dist(focalsample,TrainProj);
    [dist2 idx2] = sort(distancemat2,2);
    
    for Loopi = 1:testnum
        insideidx = idx2((dist2<dist1(Loopi)));
        if (length(insideidx)>K*length(traingnd))
            phi = 0;
        else
            phi = 1/10;
        end
        for Loopj = 1:tclassnum

            pri = sum(traingnd(insideidx)==ulabel(Loopj))/(length(insideidx)+eps)*phi;
            predict(Loopi,Loopnum,Loopj) = pri;
            if sum(traingnd(insideidx)==ulabel(Loopj))/(length(insideidx)+eps) >= 0.5;
                predict2(Loopi,Loopnum,Loopj) = 1;
            end
        end
    end
end

npred = zeros(testnum,tclassnum);
for i = 1:testnum
    for j = 1:tclassnum
        iidx = traingnd==ulabel(j);
        npred(i,j) = sum(predict(i,iidx,j));
    end
end

[junk pretest] = max(npred,[],2);
predgnd = ulabel(pretest);

end

